forceRequiredAddon("Brick_LongRangeMusic");

datablock fxDTSBrickData(brickAdminMusicData : brickMusicData)
{
	uiName = "Admin Music";
	category = "Special";
	subCategory = "Interactive";
};

datablock fxDTSBrickData(brickAdminLongMusicData : brickMusicData)
{
	uiName = "Admin Music Large";
	category = "Special";
	subCategory = "Interactive";
	musicRange = 150;
	musicDescription = Audio5xMusicLooping3d;
};

function showMusicWindow(%client)
{
	if(!isObject(%client.tempMusic))
	{
		%client.tempMusic = new fxDTSBrick() 
		{
			client = %client;
			dataBlock = brickMusicData;
			isPlanted = true;
			isTempMusic = true;
			position = "-10000 -10000 -10000";
		};
	}

	%client.wrenchBrick = %client.tempMusic;

	commandToClient(%client,'openWrenchSoundDlg',"Vehicle Stereo",1);
}

package adminMusic
{
	function serverCmdSetWrenchData(%client,%data)
	{
		if(%client.wrenchBrick.isTempMusic)
		{
			if(%client.isAdmin || %client.isSuperAdmin)
			{
				%audio = getWord(getField(%data,1),1);
				if(%client.lastMusicTimescale != 1)
					servercmdtimescale(%client,%client.lastMusicTimescale);
				messageall('',"<color:00FFFF>" @ %client.name SPC "<color:FFFF00>has just changed the music to <color:00FFFF>" @ %audio.uiName);
				for(%a=0;%a<$adminMusicBricks;%a++)
				{
					%brick = $adminMusicBrick[%a];
					if(isObject(%brick))
						%brick.setMusic(%audio);
				}
				if(%client.lastMusicTimescale != 1)
					schedule(500,0,servercmdtimescale,%client,1);
			}
			else
				messageclient(%client,'',"You must be admin to do this!");
			return;
		}
		Parent::serverCmdSetWrenchData(%client,%data);
	}

	function fxDtsBrick::onPlant(%brick)
	{
		Parent::onPlant(%brick);

		if($lastloadedbrick == %brick)
			return;

		%owner = %brick.getgroup().client;

		if(%brick.dataBlock $= "brickAdminMusicData" || %brick.dataBlock $= "brickAdminLongMusicData")
		{
			if(!(%owner.isAdmin || %owner.isSuperAdmin))
			{
				messageclient(%owner,'',"You must be admin to place this!");
				%brick.killBrick();
				return;
			}
			else
				addAdminMusicBrick(%brick);
		}
	}
};
activatepackage(adminMusic);

function addAdminMusicBrick(%brick)
{
	if(!($adminMusicBricks < 0 || $adminMusicBricks > 0))
		$adminMusicBricks = 0;
	$adminMusicBrick[$adminMusicBricks] = %brick;
	$adminMusicBricks++;
}

function servercmdmusic(%client,%timescale)
{
	if(%client.isAdmin || %client.isSuperAdmin)
	{
		if(%timescale < 0.2 || %timescale > 2)
			%timescale = 1;
		%client.lastMusicTimescale = %timescale;
		showMusicWindow(%client);
	}
	else
		messageclient(%client,'',"You must be admin to do this!");
}

function servercmddisco(%client){servercmdmusic(%client);}
function servercmdadminmusic(%client){servercmdmusic(%client);}